import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { isEngine, CardType, SelectStyleType, Card, $, CARD_KEY, decodeCardValue, CARD_VALUE_KEY, Plugin } from '@aomao/engine';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".am-engine .card-hr,.am-engine-view .card-hr {\r\n    border: 1px solid transparent;\r\n    padding: 18px 0;\r\n    border-radius: 2px 2px;\r\n}\r\n\r\n.am-engine .card-hr hr,.am-engine-view .card-hr hr {\r\n    box-sizing: border-box;\r\n    position: absolute;\r\n    top: 50%;\r\n    left: 0;\r\n    margin-top: -1px;\r\n    width: 100%;\r\n    height: 2px;\r\n    background-color: #e8e8e8;\r\n    padding: 0;\r\n    border: 1px solid transparent;\r\n}\r\n\r\n.am-engine .card-hr:hover , .am-engine .card-hr.hr-activated {\r\n    background-color: #f4f4f4;\r\n}";
styleInject(css_248z);

var Hr = /*#__PURE__*/function (_Card) {
  _inherits(Hr, _Card);

  var _super = _createSuper(Hr);

  function Hr() {
    _classCallCheck(this, Hr);

    return _super.apply(this, arguments);
  }

  _createClass(Hr, [{
    key: "toolbar",
    value: function toolbar() {
      if (!isEngine(this.editor) || this.editor.readonly) return [];
      return [{
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }];
    }
  }, {
    key: "onActivate",
    value: function onActivate(activated) {
      _get(_getPrototypeOf(Hr.prototype), "onActivate", this).call(this, activated);

      var activatedClass = 'hr-activated';
      var center = this.getCenter();

      if (activated) {
        center.addClass(activatedClass);
      } else center.removeClass(activatedClass);
    }
  }, {
    key: "onSelectByOther",
    value: function onSelectByOther(selected, value) {
      _get(_getPrototypeOf(Hr.prototype), "onSelectByOther", this).call(this, selected, value);

      this.getCenter().find('hr').css('background-color', selected ? value.rgb : '');
    }
  }, {
    key: "onActivateByOther",
    value: function onActivateByOther(activated, value) {
      this.onSelectByOther(activated, value);
    }
  }, {
    key: "render",
    value: function render() {
      this.getCenter().addClass('card-hr');
      return '<hr />';
    }
  }], [{
    key: "cardName",
    get: function get() {
      return 'hr';
    }
  }, {
    key: "cardType",
    get: function get() {
      return CardType.BLOCK;
    }
  }, {
    key: "autoActivate",
    get: function get() {
      return false;
    }
  }, {
    key: "selectStyleType",
    get: function get() {
      return SelectStyleType.BACKGROUND;
    }
  }]);

  return Hr;
}(Card);

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.markdown = function (event) {
      if (!isEngine(_this.editor) || _this.options.markdown === false) return;
      var _this$editor = _this.editor,
          change = _this$editor.change,
          command = _this$editor.command,
          node = _this$editor.node;
      var range = change.range.get();
      if (!range.collapsed || change.isComposing() || !_this.markdown) return;
      var blockApi = _this.editor.block;
      var block = blockApi.closest(range.startNode);

      if (!node.isRootBlock(block)) {
        return;
      }

      var chars = blockApi.getLeftText(block);
      var match = /^[-]{3,}$/.exec(chars);

      if (match) {
        event.preventDefault();
        blockApi.removeLeftText(block);
        command.execute(_this.constructor.pluginName);
        return false;
      }

      return;
    };

    _this.checkMarkdownMath = function (child) {
      var _this$checkMarkdown;

      return !((_this$checkMarkdown = _this.checkMarkdown(child)) === null || _this$checkMarkdown === void 0 ? void 0 : _this$checkMarkdown.match);
    };

    _this.checkMarkdown = function (node) {
      if (!isEngine(_this.editor) || !_this.markdown || !node.isText()) return;
      var text = node.text();
      var reg = /(^|\r\n|\n)((-\s*){3,})\s?(\r\n|\n|$)/;
      var match = reg.exec(text);
      return {
        reg: reg,
        match: match
      };
    };

    _this.pasteMarkdown = function (node) {
      var result = _this.checkMarkdown(node);

      if (!result) return;
      var reg = result.reg,
          match = result.match;
      if (!match) return;
      var newText = '';
      var textNode = node.clone(true).get();
      var card = _this.editor.card;

      while (textNode.textContent && (match = reg.exec(textNode.textContent))) {
        var _cardNode$get;

        //从匹配到的位置切断
        var regNode = textNode.splitText(match.index);
        newText += textNode.textContent; //从匹配结束位置分割

        textNode = regNode.splitText(match[0].length);
        var cardNode = card.replaceNode($(regNode), 'hr');
        regNode.remove(); //  match[1] 把之前的换行符补上

        newText += match[1] + ((_cardNode$get = cardNode.get()) === null || _cardNode$get === void 0 ? void 0 : _cardNode$get.outerHTML) + '\n';
      }

      newText += textNode.textContent;
      node.text(newText);
    };

    _this.pasteSchema = function (schema) {
      schema.add([{
        type: 'block',
        name: 'hr',
        isVoid: true
      }]);
    };

    _this.pasteHtml = function (node) {
      if (!isEngine(_this.editor)) return;

      if (node.name === 'hr') {
        _this.editor.card.replaceNode(node, Hr.cardName);

        return false;
      }

      return true;
    };

    _this.parseHtml = function (root, callback) {
      var results = [];
      root.find("[".concat(CARD_KEY, "=").concat(Hr.cardName)).each(function (hrNode) {
        var node = $(hrNode);
        var hr = node.find('hr');
        hr.css({
          'background-color': '#e8e8e8',
          border: '1px solid transparent',
          margin: '18px 0'
        });

        if (callback) {
          var card = _this.editor.card.find(node);

          var value = (card === null || card === void 0 ? void 0 : card.getValue()) || decodeCardValue(node.attributes(CARD_VALUE_KEY));
          hr = callback(hr, value);
        }

        node.replaceWith(hr);
        results.push(hr);
      });
      return results;
    };

    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      this.editor.on('parse:html', this.parseHtml);
      this.editor.on('paste:schema', this.pasteSchema);
      this.editor.on('paste:each', this.pasteHtml);

      if (isEngine(this.editor)) {
        this.editor.on('keydown:enter', this.markdown);
        this.editor.on('paste:markdown-check', this.checkMarkdownMath);
        this.editor.on('paste:markdown', this.pasteMarkdown);
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!isEngine(this.editor)) return;
      var card = this.editor.card;
      card.insert(Hr.cardName);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || 'mod+shift+e';
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.editor.off('parse:html', this.parseHtml);
      this.editor.off('paste:schema', this.pasteSchema);
      this.editor.off('paste:each', this.pasteHtml);

      if (isEngine(this.editor)) {
        this.editor.off('keydown:enter', this.markdown);
        this.editor.off('paste:markdown-check', this.checkMarkdownMath);
        this.editor.off('paste:markdown', this.pasteMarkdown);
      }
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'hr';
    }
  }]);

  return _default;
}(Plugin);

export default _default;
export { Hr as HrComponent };
